# -*- coding: utf-8 -*-

import xbmc
import xbmcaddon
import sys
import json
import os
import xbmcgui
import string
import random



__addon__               = xbmcaddon.Addon()
__addon_id__            = __addon__.getAddonInfo('id')
__addonname__           = __addon__.getAddonInfo('name')
__icon__                = __addon__.getAddonInfo('icon')
__addonpath__           = xbmc.translatePath(__addon__.getAddonInfo('path')).decode('utf-8')
__settings__            = xbmcaddon.Addon(id="service.KeepUSBAlive")



class MyAddon:

    def RandString(self,size=8, chars=string.ascii_uppercase + string.digits):
       return ''.join(random.choice(chars) for _ in range(size))

    def WriteFile(self,fname):
      try:
         text_file = open(fname, "w")
         text_file.write(self.RandString(200))
         text_file.close()
         if os.path.exists(fname):
            xbmc.log("Keep USB HD service: written:" + str(fname), level=xbmc.LOGNOTICE)
         else:
            xbmc.log("Keep USB HD service: not written:" + str(fname), level=xbmc.LOGNOTICE)
      except Exception , msg:
         xbmc.log("Keep USB HD service:" + str(msg), level=xbmc.LOGNOTICE)

    def __init__(self):
         writetime = __settings__.getSetting("writetime")
         count = 0
         xbmc.log("Keep USB HD service:" + str(writetime), level=xbmc.LOGNOTICE)
         while(not xbmc.abortRequested):
             xbmc.sleep(100)
             count += 1
             
             if count == int(writetime) * 10 * 60:
                count = 1
                try:
                   usbenable1 = __settings__.getSetting("path1enable")
                   usbenable2 = __settings__.getSetting("path2enable")
                   usbenable3 = __settings__.getSetting("path3enable")
                   usbenable4 = __settings__.getSetting("path4enable")
                   
                   usbpath1 = __settings__.getSetting("usbpath1")
                   usbpath2 = __settings__.getSetting("usbpath2")
                   usbpath3 = __settings__.getSetting("usbpath3")
                   usbpath4 = __settings__.getSetting("usbpath4")
                   
                   lastfile = __settings__.getSetting("lastfile")
                   
                   rfilename = self.RandString() + ".txt"
                   __settings__.setSetting("lastfile",rfilename)
                   
                   xbmc.log("Keep USB HD service: " + str(usbenable1), level=xbmc.LOGNOTICE)
                   xbmc.log("Keep USB HD service: " + str(usbpath1), level=xbmc.LOGNOTICE)
                   xbmc.log("Keep USB HD service: " + str(lastfile), level=xbmc.LOGNOTICE)
                   xbmc.log("Keep USB HD service: " + str(rfilename), level=xbmc.LOGNOTICE)
                   
                   if str(usbenable1) == "true":
                      xbmc.log("Keep USB HD service: USB1 enabled", level=xbmc.LOGNOTICE)
                      if os.path.exists(usbpath1 + lastfile):
                          try: 
                              os.remove(usbpath1 + lastfile)
                          except Exception , msg:
                              xbmc.log("Keep USB HD service:" + str(msg), level=xbmc.LOGNOTICE)
                      self.WriteFile(usbpath1 + rfilename)
                      
                   if str(usbenable2) == "true":
                      if os.path.exists(usbpath2 + lastfile):
                          try: 
                              os.remove(usbpath2 + lastfile)
                          except Exception , msg:
                              xbmc.log("Keep USB HD service:" + str(msg), level=xbmc.LOGNOTICE)
                      self.WriteFile(usbpath2 + rfilename)
                      
                   if str(usbenable3) == "true":
                      if os.path.exists(usbpath3 + lastfile):
                          try: 
                              os.remove(usbpath3 + lastfile)
                          except Exception , msg:
                              xbmc.log("Keep USB HD service:" + str(msg), level=xbmc.LOGNOTICE)
                      self.WriteFile(usbpath3 + rfilename)
                      
                   if str(usbenable4) == "true":
                      if os.path.exists(usbpath4 + lastfile):
                          try: 
                              os.remove(usbpath4 + lastfile)
                          except Exception , msg:
                              xbmc.log("Keep USB HD service:" + str(msg), level=xbmc.LOGNOTICE)
                      self.WriteFile(usbpath4 + rfilename)      
                except Exception , msg:
                   xbmc.log("Keep USB HD service:" + str(msg), level=xbmc.LOGNOTICE)


    def Msg(self,mss):
         note = '{"id":1,"jsonrpc":"2.0","method":"GUI.ShowNotification","params":{"title":"IP","message":"' + mss + '"}}'
         result = xbmc.executeJSONRPC(note)
         


xbmc.log("Keep USB HD service: start", level=xbmc.LOGNOTICE)
MyAddon()
xbmc.log("Keep USB HD service: stop", level=xbmc.LOGNOTICE)
     
